git-resolve-scripton commit Try to find the optimum merge base while resolving. (9585e40)
   1#!/bin/sh
   2#
   3# Copyright (c) 2005 Linus Torvalds
   4#
   5# Resolve two trees.
   6#
   7. git-sh-setup-script || die "Not a git archive"
   8
   9usage () {
  10        die "git-resolve-script <head> <remote> <merge-message>"
  11}
  12
  13dropheads() {
  14        rm -f -- "$GIT_DIR/MERGE_HEAD" \
  15                "$GIT_DIR/LAST_MERGE" || exit 1
  16}
  17
  18head=$(git-rev-parse --verify "$1"^0) &&
  19merge=$(git-rev-parse --verify "$2"^0) &&
  20merge_msg="$3" || usage
  21
  22#
  23# The remote name is just used for the message,
  24# but we do want it.
  25#
  26if [ -z "$head" -o -z "$merge" -o -z "$merge_msg" ]; then
  27        usage
  28fi
  29
  30dropheads
  31echo $head > "$GIT_DIR"/ORIG_HEAD
  32echo $merge > "$GIT_DIR"/LAST_MERGE
  33
  34common=$(git-merge-base $head $merge)
  35if [ -z "$common" ]; then
  36        die "Unable to find common commit between" $merge $head
  37fi
  38
  39if [ "$common" == "$merge" ]; then
  40        echo "Already up-to-date. Yeeah!"
  41        dropheads
  42        exit 0
  43fi
  44if [ "$common" == "$head" ]; then
  45        echo "Updating from $head to $merge."
  46        git-read-tree -u -m $head $merge || exit 1
  47        echo $merge > "$GIT_DIR"/HEAD
  48        git-diff-tree -p $head $merge | git-apply --stat
  49        dropheads
  50        exit 0
  51fi
  52
  53# Find an optimum merge base if there are more than one candidates.
  54LF='
  55'
  56common=$(git-merge-base -a $head $merge)
  57case "$common" in
  58?*"$LF"?*)
  59        echo "Trying to find the optimum merge base."
  60        G=.tmp-index$$
  61        best=
  62        best_cnt=-1
  63        for c in $common
  64        do
  65                rm -f $G
  66                GIT_INDEX_FILE=$G git-read-tree -m $c $head $merge \
  67                        2>/dev/null || continue
  68                # Count the paths that are unmerged.
  69                cnt=`GIT_INDEX_FILE=$G git-ls-files --unmerged | wc -l`
  70                if test $best_cnt -le 0 -o $cnt -le $best_cnt
  71                then
  72                        best=$c
  73                        best_cnt=$cnt
  74                        if test "$best_cnt" -eq 0
  75                        then
  76                                # Cannot do any better than all trivial merge.
  77                                break
  78                        fi
  79                fi
  80        done
  81        rm -f $G
  82        common="$best"
  83esac
  84
  85echo "Trying to merge $merge into $head using $common."
  86git-update-cache --refresh 2>/dev/null
  87git-read-tree -u -m $common $head $merge || exit 1
  88result_tree=$(git-write-tree  2> /dev/null)
  89if [ $? -ne 0 ]; then
  90        echo "Simple merge failed, trying Automatic merge"
  91        git-merge-cache -o git-merge-one-file-script -a
  92        if [ $? -ne 0 ]; then
  93                echo $merge > "$GIT_DIR"/MERGE_HEAD
  94                die "Automatic merge failed, fix up by hand"
  95        fi
  96        result_tree=$(git-write-tree) || exit 1
  97fi
  98result_commit=$(echo "$merge_msg" | git-commit-tree $result_tree -p $head -p $merge)
  99echo "Committed merge $result_commit"
 100echo $result_commit > "$GIT_DIR"/HEAD
 101git-diff-tree -p $head $result_commit | git-apply --stat
 102dropheads